#include<iostream>
#include<cmath>
#include<vector>

using namespace std;

class Shape {

public:
  virtual double getArea() const =0;

};

class Circle: public Shape {
public:
  Circle() : radius(1.) {
  }

  explicit Circle(double r) : radius(r) {
  }

  virtual double getArea() const {
    cout<<"Circle::getArea"<<endl;    
    return M_PI*radius*radius; 
  }

private:
  double radius;
};

class Square: public Shape {
public:
  Square() : length(1.) {
  }

  explicit Square(double l) : length(l) {
  }

  virtual double getArea() const {
    cout<<"Square::getArea"<<endl;    
    return length*length; 
  }
  
private:
  double length;
};


int main() {
  vector<Shape*> myShapes;
  myShapes.push_back(new Circle(2.));  
  myShapes.push_back(new Square(3.));  

  cout<<myShapes[0]->getArea()<<endl;
  cout<<myShapes[1]->getArea()<<endl;

  delete myShapes[0];
  delete myShapes[1];
}
